<?php
/**
 * Created by PhpStorm.
 * User: leonardooliveira
 * Date: 25/02/2015
 * Time: 10:22
 */

namespace Expedicao\Logic\ExpedicaoPedido;

use Estoque\Entities\Lanctoestoq;
use Fiscal\Entities\Notafiscal;
use Geral\Entities\Expedicao;
use Geral\Entities\Itempedido;
use Geral\Entities\Paramfilial;
use Geral\Entities\Parampedido;
use Geral\Entities\Pedido;
use Geral\Entities\Prodfili;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Indeterminado\Entities\Encargoped;
use Pedidos\Entities\Parexpedicao;
use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
use Setforms2\Shared\Registry;

class ExpedePedido
{

    public static function expedirPedido(
        $filiproc, $cdfilial, $cdempresa, $cdtipooper, $cdserie, $cdcliente, $idtpijurtran, $nrinsjurtran,
        $nrplaca, $sgufveiculo, $idpgfrettrancli, $dsqtdevolped, $dsespevolped, $dsmarcvolped, $dsnumevolped,
        $vrpbruvolped, $vrpliqvolped, $nrpedido
    )
    {
        try {

            /** @var $paramfilial Paramfilial */
            $paramfilial = Paramfilial::findOneByCdfilialAndNrorg($filiproc, Ambiente::getNrorg());
            $dtprocess = $paramfilial->getDtprocessa()->format('d/m/Y');
            $nrlanctonf = NovoCodigo::geraCodigo(Ambiente::getNrorg(), 'LANCNF/FILIAL' . $filiproc);
            $nrlancestq = NovoCodigo::geraCodigo(Ambiente::getNrorg(), 'LANCTOEST' . $filiproc);            
            $produtos = self::getItempedito($cdfilial, $nrpedido);
            $encargos = self::getEncargos($cdfilial, $nrpedido);
            
            $nrlanctonfOut = '';
            $nrlancestqOut = '';
            $procedure = new Procedure('GERA_NOTAFISCAL_CORPO');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $filiproc, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIEMIT', Param::PARAM_INPUT, $cdfilial, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $cdempresa, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDTIPOOPER', Param::PARAM_INPUT, $cdtipooper, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSERIE', Param::PARAM_INPUT, $cdserie, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCLIENTE', Param::PARAM_INPUT, $cdcliente, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTENTRSAID', Param::PARAM_INPUT, $dtprocess, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDSISTEMA', Param::PARAM_INPUT, 'EXP', Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_PRXLANCTONF', Param::PARAM_OUTPUT, $nrlanctonfOut, Param::PARAM_TYPE_STR, 12));
            $procedure->addParam(new Param('P_PRXLANCESTQ', Param::PARAM_OUTPUT, $nrlancestqOut, Param::PARAM_TYPE_STR, 12));
            $procedure->addParam(new Param('P_ATUAESTOQUE', Param::PARAM_INPUT, 'S', Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRAPURACFAT', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $nrlanctonf, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDTPIJURTRAN', Param::PARAM_INPUT, $idtpijurtran, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRINSJURTRAN', Param::PARAM_INPUT, $nrinsjurtran, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRPLACAVEIC', Param::PARAM_INPUT, $nrplaca, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_SGUFVEIC', Param::PARAM_INPUT, $sgufveiculo, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDPGTOFRETE', Param::PARAM_INPUT, $idpgfrettrancli, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSQTDEVOLU', Param::PARAM_INPUT, $dsqtdevolped, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSESPECVOLU', Param::PARAM_INPUT, $dsespevolped, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSMARCAVOLU', Param::PARAM_INPUT, $dsmarcvolped, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSNUMEVOLU', Param::PARAM_INPUT, $dsnumevolped, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRPBRUTOVOLU', Param::PARAM_INPUT, $vrpbruvolped, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRPLIQUVOLU', Param::PARAM_INPUT, $vrpliqvolped, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCESTQ', Param::PARAM_INPUT, $nrlancestq, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCORIG', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTLANCAMENNF', Param::PARAM_INPUT, $dtprocess, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDGEROUTDOCU', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTCOMPFATUR', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPTOVNDFATURNF', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
            $procedure->call();
            Registry::getEntityManager()->flush();

            foreach ($produtos as $itemPedido) {
                $cdalmoxarife = self::getAlmoxarifado($cdfilial, $itemPedido['CDPRODUTO']);
                $cdlocalestoq = self::getLocalestoque($cdfilial, $itemPedido['CDPRODUTO']);
                $valores = self::calculaQuantidade($cdfilial, $itemPedido);
                $procedure = new Procedure('GERA_NOTAFISCAL_PRODUTO');
                $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $filiproc, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $nrlanctonf, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $valores['CDPRODUTO'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDPRODEMIS', Param::PARAM_INPUT, $valores['CDPRODEMIS'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_DSPRODEMIS', Param::PARAM_INPUT, $valores['DSPRODEMIS'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_QTITEMPROD', Param::PARAM_INPUT, $valores['EXQTITEM'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_VRUNITITEM', Param::PARAM_INPUT, $valores['EXVRITEM'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_VRDESCITEM', Param::PARAM_INPUT, $itemPedido['VRDESITPED'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDFILIALITG', Param::PARAM_INPUT, $cdfilial, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_NRINTEGRACAO', Param::PARAM_INPUT, $nrpedido, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_NRITEMINTEGR', Param::PARAM_INPUT, $itemPedido['NRITEMPED'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDCSTINFUSU', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDCFOPINFUSU', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDSUFXINFUSU', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDALMOXARIFE', Param::PARAM_INPUT, $cdalmoxarife, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDLOCALESTOQ', Param::PARAM_INPUT, $cdlocalestoq, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_NRLOTEESTQ', Param::PARAM_INPUT, $valores['NRLOTEESTQ'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_NRSUBLOTE', Param::PARAM_INPUT, $valores['NRSUBLOTE'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_IDCONFORITEM', Param::PARAM_INPUT, 'S', Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_IDTPNFCREDEB', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_QTVOLUITEM', Param::PARAM_INPUT, 0, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDSERVFILI', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDFILIAPUR', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDMARCA', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDSERVFATU', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
                $procedure->call();

                self::updateItempedido($cdfilial, $nrpedido, $itemPedido['NRITEMPED'], $valores['EXQTITEM']);

            }

            foreach($encargos as $encargo) {
                $procedure = new Procedure('GERA_NOTAFISCAL_ENCARGO');
                $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $filiproc, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $nrlanctonf, Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_CDENCARGO', Param::PARAM_INPUT, $encargo['CDENCARGO'], Param::PARAM_TYPE_STR));
                $procedure->addParam(new Param('P_VRITEMENCA', Param::PARAM_INPUT, $encargo['VALOR'], Param::PARAM_TYPE_STR));
                $procedure->call();
            }

            $procedure = new Procedure('GERA_NOTAFISCAL_FECHAMENTO');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $filiproc, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $nrlanctonf, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DATAPROC', Param::PARAM_INPUT, $dtprocess, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCESTQ', Param::PARAM_INPUT, $nrlancestq, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_EVOLESTOQ', Param::PARAM_INPUT, 'S', Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDBLOQTRANS', Param::PARAM_INPUT, 'N', Param::PARAM_TYPE_STR));
            $procedure->call();

            return array(
                'NRLANCTONF' => $nrlanctonf,
                'NRLANCESTQ' => $nrlancestq
            );

        } catch (\Exception $e) {
            throw $e;
            return null;

        }
    }
    
    public static function getItempedito($cdfilial, $nrpedido){
        try {
            /** @var $itemPedidoRepo \Geral\Repositories\Itempedido */
            $itemPedidoRepo = Itempedido::getRepository();
            $itemPedido = $itemPedidoRepo->getItempedido($cdfilial, $nrpedido);

            return $itemPedido;
        } catch (\Exception $e) {
            throw $e;
            return null;
        }
    }
    
    public static function getEncargos($cdfilial, $nrpedido){
        try {
            /** @var $encargosRepo \Indeterminado\Repositories\Encargoped */
            $encargosRepo = Encargoped::getRepository();
            $encargos = $encargosRepo->getEncargoPed($cdfilial, $nrpedido);

            return $encargos;
        } catch (\Exception $e) {
            throw $e;
            return null;
        }
    }

    public static function getQuantidadeDisponível($cdfilial, $nrpedido){
        try {

            $itensPedido = self::getItempedito($cdfilial, $nrpedido);

            $estoqueNegativoProduto = array();
            foreach($itensPedido as $item) {
                /** @var $pedidosEntity \Geral\Repositories\Pedido */
                $pedidosEntity = Pedido::getRepository();
                $quantidadeEstoque = $pedidosEntity->getQtde($cdfilial, $item['CDPRODUTO'], $nrpedido, $item['NRITEMPED']);
                if(empty($quantidadeEstoque)){
                    $estoqueNegativoProduto[0]['CDFILIAL'] = $item['CDFILIAL'];
                    $estoqueNegativoProduto[0]['CDPRODUTO'] = $item['CDPRODUTO'] . ' - ' . $item['NMPRODUTO'];
                    $estoqueNegativoProduto[0]['CDALMOXARIFE'] = '';
                    $estoqueNegativoProduto[0]['QTAEXP'] = $item['QTDEAEXP'];
                    $estoqueNegativoProduto[0]['QTDISPONIVEL'] = 0;
                }
            }

            return $estoqueNegativoProduto;

        } catch (\Exception $e) {
            throw $e;
            return null;
        }
    }

    public static function updatePedido($cdfilial, $nrpedido, $idsitpedido, $cdtipooper = null){
        try {
            /** @var $pedido Pedido */
            $pedido = Pedido::findOneByCdfilialAndNrpedido($cdfilial, $nrpedido);
            $pedido->setIdsitpedido($idsitpedido);
            $pedido->setCdtipooper($cdtipooper);
            $pedido->persist();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function updateItempedido($cdfilial, $nrpedido, $nritempedido, $qtexpitemped){
        try {
            /** @var $itemPedido Itempedido */
            $itemPedido = Itempedido::findOneByNrorgAndCdfilialAndNrpedidoAndNritemped(
                Ambiente::getNrorg(), $cdfilial, $nrpedido, $nritempedido
            );
            $itemPedido->setQtexpitemped($qtexpitemped);
            $itemPedido->setIdsititemped('4');
            $itemPedido->setCdoperador(Ambiente::getCdOperador());
            $itemPedido->persist();
            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function updateNotafiscal(
        $cdfilial, $nrlanctonf, $cdvendedor, $cdrotatrans, $nrexpedicao, $dsqtdevolu, $vrpbrutovolu, $vrpliquvolu,
        $cdopergera
    ){
        try {
            $notafiscal = Notafiscal::findOneByCdfilialAndNrlanctonfAndNrorg($cdfilial, $nrlanctonf, Ambiente::getNrorg());
            $notafiscal->setCdvendedor($cdvendedor);
            $notafiscal->setCdrotatrans($cdrotatrans);
            $notafiscal->setNrexpedicao($nrexpedicao);
            $notafiscal->setDsqtdevolu($dsqtdevolu);
            $notafiscal->setVrpbrutovolu($vrpbrutovolu);
            $notafiscal->setVrpliquvolu($vrpliquvolu);
            $notafiscal->setCdopergera($cdopergera);
            $notafiscal->persist();

            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function novaExpedicao($cdfilial, $cdviatura = NULL, $cdopersep = NULL, $cdoperconf = NULL){
        try {
            $nrexpedicao = NovoCodigo::geraCodigo(Ambiente::getNrorg(), 'NREXPEDICAO' . $cdfilial);

            $expedicao = new Expedicao();
            $expedicao->setCdfilial(Ambiente::getCdFilial());
            $expedicao->setNrorg(Ambiente::getNrorg());
            $expedicao->setNrexpedicao($nrexpedicao);
            $expedicao->setCdfilialped($cdfilial);
            $expedicao->setCdviatura($cdviatura);
            $expedicao->setCdopersep($cdopersep);
            $expedicao->setCdoperconf($cdoperconf);
            $expedicao->setDtinclusao(DateUtil::getDataAtual());
            $expedicao->persist();

            Registry::getEntityManager()->flush();

            return $nrexpedicao;
        } catch (\Exception $e) {
            throw $e;
            return null;
        }
    }

    public static function updateLanctoestoque($cdfilial, $nrlanctonf, $cdoperador){
        try {
            $lanctoest = Lanctoestoq::findOneByCdfilialAndNrlanctonfAndNrorg($cdfilial, $nrlanctonf, Ambiente::getNrorg());
            if($lanctoest){
                $lanctoest->setCdoperador($cdoperador);
                $lanctoest->persist();
            }

            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function callProcedureAtivoExp($cdfilial, $nrexpedicao, $cdoperador){
        try {
            $procedure = new Procedure('ATUALIZA_ATIVO_EXP');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $cdfilial, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NREXPEDICAO', Param::PARAM_INPUT, $nrexpedicao, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR));
            $procedure->call();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function getAlmoxarifado($cdfilial, $cdproduto)
    {
        $paramfilial = Paramfilial::findOneByCdfilialAndNrorg($cdfilial, Ambiente::getNrorg());
        if ($paramfilial && $paramfilial->getIdutilalmox() == 'S') {
            $prodfili = Prodfili::findOneByCdprodutoAndCdfilialAndNrorg($cdproduto, $cdfilial, Ambiente::getNrorg());
            if ($prodfili && $prodfili->getCdalmoxprcli()) {
                return $prodfili->getCdalmoxprcli();
            } else {
                return $paramfilial->getCdalmoxarife();
            }
        } else {
            return NULL;
        }
    }

    public static function getLocalestoque($cdfilial, $cdproduto)
    {
        $paramfilial = Paramfilial::findOneByCdfilialAndNrorg($cdfilial, Ambiente::getNrorg());
        if ($paramfilial && $paramfilial->getIdutillcestq() == 'S') {
            $prodfili = Prodfili::findOneByCdprodutoAndCdfilialAndNrorg($cdproduto, $cdfilial, Ambiente::getNrorg());
            if ($prodfili && $prodfili->getCdlocalprcli()) {
                return $prodfili->getCdlocalprcli();
            } else {
                return $paramfilial->getCdlocalestoq();
            }
        } else {
            return NULL;
        }
    }

    public static function calculaQuantidade($cdfilial, $itemPedido)
    {
        /** @var $parexpedicaoRepo \Pedidos\Repositories\Parexpedicao */
        $parexpedicaoRepo = Parexpedicao::getRepository();
        $parexpedicao = $parexpedicaoRepo->getParexpedicao($cdfilial);

        /** @var $parpedidoRepo \Geral\Repositories\Parampedido */
        $parpedidoRepo = Parampedido::getRepository();
        $parpedido = $parpedidoRepo->getParPedido($cdfilial);

        if (isset($parpedido) && $parpedido[0]['IDTABPRECO'] == '1') {
            $exvritem = $itemPedido['VRPREUNITPED'];
        } else {
            $exvritem = $itemPedido['VrCusto'] * $itemPedido['VRFATPRECO'];
        }

        if ($parexpedicao[0]['IDGERPRODEST'] == '2') {
            $cdproduto = $itemPedido['CDPRODESTO'];
            $exqtitem = ($itemPedido['QTDEAEXP'] * $itemPedido['VRFATOCONV']);
            if ($itemPedido['VRFATOCONV'] > 0) {
                $exvritem = $exvritem / $itemPedido['VRFATOCONV'];
            }
        } else {
            $exqtitem = $itemPedido['QTDEAEXP'];
            $cdproduto = $itemPedido['CDPRODUTO'];
        }

        if (!empty($itemPedido['CDEMISSAOITPED'])) {
            $cdprodemiss = $itemPedido['CDEMISSAOITPED'];
        } else {
            $cdprodemiss = $itemPedido['CDARVPROD'];
        }

        if (!empty($itemPedido['DSEMISSAOITPED'])) {
            $dsprodemiss = $itemPedido['DSEMISSAOITPED'];
        } else {
            $dsprodemiss = $itemPedido['NMPRODUTO'];
        }

        //A ser implementado
        $nrsublote = '';
        $nrloteest = '';

        return array(
            'CDPRODUTO' => $cdproduto,
            'EXQTITEM' => $exqtitem,
            'EXVRITEM' => $exvritem,
            'CDPRODEMIS' => $cdprodemiss,
            'DSPRODEMIS' => $dsprodemiss,
            'NRSUBLOTE' => $nrsublote,
            'NRLOTEESTQ' => $nrloteest,
        );
    }

    public static function formataData($data)
    {
        if (strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDatadeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }
} 