-- ========================================================================== --
-- SISTEMA         : COMISSARIA                                               --
-- DATA DA CRIAO : 28/06/99  13:57                                          --
-- PROGRAMADOR     : Leonardo Monteiro                                        --
-- OBJETIVOS       : Unir as tabelas PADVOOTRE, PADPREFIXO e PADEQUIP.        --
-- MANUTENOES     : LUCIANA CORREA - MULTI-EMPRESA                           --
-- ========================================================================== --
-- @C:\WIN_V4\SQL\END_CONV\ORACLE\2410_ATEVIEO.SQL
-- ========================================================================== --
CREATE OR REPLACE VIEW PAD_VOOPREFEQUI(CDFILIAL,CDCIA,NRVOO,CDTRECHO,SGPREFIXO,
                                       CDEQUIP,SGEQUIP,SGBASEORI,SGBASEDES,
                                       CDSERVICO,QTSERV,VRLOADSE,NRPROPAX,
                                       DSSERVICO,IDSERVICO,CDCLASSE,CDCICLO,
                                       SGCLASSE,IDCICLO,IDPROPSERV,QTSESTBY,
                                       /*IDGERBREAK,*/IDSITSERVICO,IDTIPMANUAL,
                                       IDTPPRECO,VRPESOSE,IDFATSE,CDARVPROD,
                                       IDSERVESP,SGUNIDADE)
AS
SELECT PA.CDFILIAL,PA.CDCIA,PA.NRVOO,PA.CDTRECHO,PA.SGPREFIXO,PA.CDEQUIP ,PA.SGEQUIP,
       BO.SGBASE SGBASEORI,BD.SGBASE SGBASEDES  ,PA.CDSERVICO,PA.QTSERVOO,PA.VRLOADSEVOO,
       PA.NRPROPAXVOO,PA.NMPRODUTO,PA.IDSERVICO ,PA.CDCLASSE,PA.CDCICLO,CL.SGCLASSE,
       CI.IDCICLO,PA.IDPROPSEVOO,PA.QTSESTBYVOO,/*IDGERBREAK,*/DECODE(PA.IDPRODATIVPR,'S','1','2') IDPRODATIVPR,
       PA.IDNACPRODUTO,PA.IDTPPRECO,PA.VRPESOUNID,PA.IDFATSERV,PA.CDARVPROD,PA.IDSERVESP,PA.SGUNIDADE
FROM 
   (
      SELECT PV.CDFILIAL,PV.CDCIA,PV.NRVOO,PV.CDTRECHO,VO.SGPREFIXO,
             VO.CDEQUIP,EQ.SGEQUIP,VT.CDBASEORI,VT.CDBASEDES,PV.CDSERVICO,
             PV.QTSERVOO,PV.VRLOADSEVOO,PV.NRPROPAXVOO,PR.NMPRODUTO,PR.CDCLASSE,
             PR.CDCICLO,PR.IDSERVICO,PV.IDPROPSEVOO,PV.QTSESTBYVOO,/*PR.IDGERBREAK,*/
             PR.IDPRODATIVPR,PR.IDNACPRODUTO,PR.IDTPPRECO,PR.VRPESOUNID,PR.IDFATSERV,
             PR.CDARVPROD,PR.IDSERVESP,PR.SGUNIDADE
        FROM PADVOOTRE PV
             INNER JOIN PRODUTO PR ON PR.CDPRODUTO = PV.CDSERVICO
             INNER JOIN VOO VO ON VO.CDFILIAL = PV.CDFILIAL AND
                                  VO.CDCIA = PV.CDCIA AND
                                  VO.NRVOO = PV.NRVOO
             INNER JOIN VOOTRECHO VT ON VT.CDFILIAL = PV.CDFILIAL AND
                                        VT.CDCIA = PV.CDCIA AND
                                        VT.NRVOO = PV.NRVOO AND
                                        VT.CDTRECHO = PV.CDTRECHO
             INNER JOIN EQUIPAMENTO EQ ON EQ.CDEQUIP = VO.CDEQUIP
       WHERE PR.IDPRODCOMISS = '1' AND
             PR.IDSERVICO <> '4'
      UNION ALL
      SELECT PP.CDFILIAL,PP.CDCIA,VO.NRVOO,VT.CDTRECHO,PP.SGPREFIXO,
             VO.CDEQUIP,EQ.SGEQUIP,VT.CDBASEORI,VT.CDBASEDES,PP.CDSERVICO,
             PP.QTSERPRE,PP.VRLOADSEPRE,PP.NRPROPAXPRE,PR.NMPRODUTO,PR.CDCLASSE ,
             PR.CDCICLO,PR.IDSERVICO,PP.IDPROPSEPRE,PP.QTSESTBYPRE,/*SC.IDGERBREAK,*/
             PR.IDPRODATIVPR,PR.IDNACPRODUTO,PR.IDTPPRECO,PR.VRPESOUNID,PR.IDFATSERV,
             PR.CDARVPROD,PR.IDSERVESP,PR.SGUNIDADE
        FROM PADPREFIXO PP
             INNER JOIN PRODUTO PR ON PR.CDPRODUTO = PP.CDSERVICO
             INNER JOIN VOO VO ON VO.CDFILIAL = PP.CDFILIAL AND
                                  VO.CDCIA = PP.CDCIA AND
                                  VO.SGPREFIXO = PP.SGPREFIXO
             INNER JOIN VOOTRECHO VT ON VT.CDFILIAL = PP.CDFILIAL AND
                                      VT.CDCIA = PP.CDCIA AND
                                      VT.NRVOO = VO.NRVOO
             INNER JOIN EQUIPAMENTO EQ ON EQ.CDEQUIP = VO.CDEQUIP
       WHERE PR.IDPRODCOMISS = '1' AND
             PR.IDSERVICO <> '4' AND
             NOT EXISTS (SELECT 1
                           FROM PADVOOTRE PV
                                INNER JOIN PRODUTO PVPR ON PV.CDSERVICO = PVPR.CDPRODUTO
                           WHERE PV.CDFILIAL = PP.CDFILIAL
                             AND PV.CDCIA = PP.CDCIA
                             AND PV.NRVOO = VO.NRVOO
                             AND PV.CDTRECHO = VT.CDTRECHO
                             AND PVPR.IDSERVICO = PR.IDSERVICO)
      UNION ALL
      SELECT PE.CDFILIAL,PE.CDCIA,VO.NRVOO,VT.CDTRECHO,VO.SGPREFIXO,
             PE.CDEQUIP,EQ.SGEQUIP,VT.CDBASEORI,VT.CDBASEDES,PE.CDSERVICO,
             PE.QTSERVEQ,PE.VRLOADSEEQ,PE.NRPROPAXEQ,PR.NMPRODUTO,PR.CDCLASSE,
             PR.CDCICLO,PR.IDSERVICO,PE.IDPROPSEEQ,PE.QTSESTBYEQ,/*SC.IDGERBREAK,*/
             PR.IDPRODATIVPR,PR.IDNACPRODUTO,PR.IDTPPRECO,PR.VRPESOUNID,PR.IDFATSERV,
             PR.CDARVPROD,PR.IDSERVESP,PR.SGUNIDADE
      FROM PADEQUIP PE
           INNER JOIN PRODUTO PR ON PR.CDPRODUTO = PE.CDSERVICO
           INNER JOIN VOO VO ON VO.CDFILIAL = PE.CDFILIAL AND
                                VO.CDCIA = PE.CDCIA AND
                                VO.CDEQUIP = PE.CDEQUIP
           INNER JOIN VOOTRECHO VT ON VT.CDFILIAL = PE.CDFILIAL AND
                                      VT.CDCIA = PE.CDCIA AND
                                      VT.NRVOO = VO.NRVOO
           INNER JOIN EQUIPAMENTO EQ ON EQ.CDEQUIP = VO.CDEQUIP
      WHERE PR.IDPRODCOMISS = '1' AND
            PR.IDSERVICO <> '4' AND
            NOT EXISTS (SELECT 1
                           FROM PADVOOTRE PV
                                INNER JOIN PRODUTO PVPR ON PV.CDSERVICO = PVPR.CDPRODUTO
                           WHERE PV.CDFILIAL = PE.CDFILIAL
                             AND PV.CDCIA = PE.CDCIA
                             AND PV.NRVOO = VO.NRVOO
                             AND PV.CDTRECHO = VT.CDTRECHO
                             AND PVPR.IDSERVICO = PR.IDSERVICO) AND
            NOT EXISTS (SELECT 1
                           FROM PADPREFIXO PP
                                INNER JOIN VOO VOPP ON VOPP.CDFILIAL = PP.CDFILIAL AND
                                                       VOPP.CDCIA = PP.CDCIA AND
                                                       VOPP.SGPREFIXO = PP.SGPREFIXO
                                INNER JOIN VOOTRECHO VTPP ON VTPP.CDFILIAL = PP.CDFILIAL AND
                                                             VTPP.CDCIA = PP.CDCIA AND
                                                             VTPP.NRVOO = VOPP.NRVOO
                                INNER JOIN PRODUTO PPPR ON PP.CDSERVICO = PPPR.CDPRODUTO
                           WHERE PP.CDFILIAL = PE.CDFILIAL
                             AND PP.CDCIA = PE.CDCIA
                             AND VOPP.NRVOO = VO.NRVOO
                             AND VTPP.CDTRECHO = VT.CDTRECHO
                             AND PPPR.IDSERVICO = PR.IDSERVICO)
   ) PA
     INNER JOIN CLASSE CL ON CL.CDCLASSE = PA.CDCLASSE
     INNER JOIN CICLO CI ON CI.CDCICLO = PA.CDCICLO
     INNER JOIN BASE BO ON BO.CDBASE = PA.CDBASEORI
     INNER JOIN BASE BD ON BD.CDBASE = PA.CDBASEDES  

/
